; FILTTEST.ASM--
; Copyright (c) 2008 Hjort Nidudsson
;
; Change history:
; 09 Nov 2008	- Created
;

INCLUDE		clib.inc
INCLUDE		dos.inc
INCLUDE		fblk.inc
INCLUDE		string.inc
INCLUDE		filter.inc

_TEXT		SEGMENT

		.386p

test_binary:	les	bx,filt
		or	bx,bx
		jnz	SHORT @@dotest
		mov	ax,1
		jmp	SHORT @@ok
@@dotest:	cmp	dx,es:[bx.filt_min_date]	; DX: date
		jb	SHORT @@no_match
		cmp	es:[bx.filt_max_date],0
		jne	SHORT @@testmaxdate
@@testsize:	cmp	eax,es:[bx.filt_min_size]       ; EAX: size
		jb	SHORT @@no_match
		mov	edx,eax
		xor	eax,eax
		cmp	eax,es:[bx.filt_max_size]
		jne	SHORT @@testmaxsize
@@testflag:	mov	dx,cx				; CX: flag
		and	dx,es:[bx.filt_flag]
		cmp	dx,cx
		jne	SHORT @@no_match
@@ok:		inc	ax
		ret
@@testmaxdate:	cmp	dx,es:[bx.filt_max_date]
		jbe	SHORT @@testsize
		jmp	SHORT @@no_match
@@testmaxsize:	cmp	edx,es:[bx.filt_max_size]
		jbe	SHORT @@testflag
@@no_match:	xor	ax,ax
		ret

test_name:      xor	ax,ax
		cmp	al,es:[bx.filt_include]
		jne	SHORT @@include
@@excl:		cmp	al,es:[bx.filt_exclude]
		jne	SHORT @@exclude
@@ok:		inc	ax
@@toend:	ret
@@include:      push	dx	; segmet name
		push	cx      ; offset name
		push	dx
		push	cx
		push	ES
		add	bx,filt_include
		push	bx
		call	cmpwargs
		pop	cx
		pop	dx
		or	ax,ax
		jz	SHORT @@toend
		xor	ax,ax
		les	bx,filt
		jmp	SHORT @@excl
@@exclude:      push	dx
		push	cx
		push	ES
		add	bx,filt_exclude
		push	bx
		call	cmpwargs
		or	ax,ax
		jz	SHORT @@ok
		xor	ax,ax
		ret

_TEXT		ENDS

PPROC		filter_fblk
ARG		filt:	DPTR,\
		fblk:	DPTR
		les	bx,fblk
		mov	eax,es:[bx.fb_size]
		mov	dx,es:[bx.fb_date]
		mov	cx,es:[bx.fb_flag]
		call	test_binary
		jz	SHORT @@toend
		cmp	ax,2
		je	SHORT @@toend
		mov	dx,WORD PTR [fblk+2]
		mov	cx,WORD PTR [fblk]
		add	cx,fb_name
		call	test_name
@@toend:	ret
PEND		filter_fblk

PPROC		filter_wblk
ARG		filt:	DPTR,\
		wblk:	DPTR
		les	bx,wblk
		mov	eax,es:[bx.wf_sizeax]
		mov	dx,es:[bx.wf_datemodified]
		mov	cx,WORD PTR es:[bx.wf_attrib]
		call	test_binary
		jz	SHORT @@toend
		cmp	ax,2
		je	SHORT @@toend
		mov	dx,WORD PTR [wblk+2]
		mov	cx,WORD PTR [wblk]
		add	cx,wf_name
		call	test_name
@@toend:	ret
PEND		filter_wblk

		END
